      integer j, Nr, iterc, convg, phiconvg, piconvg
      integer inform, nrmax,iterma,firstloop
      parameter( iterma = 1000 )
      parameter( nrmax = 1 000 000 )
      real*8     testfunction(nrmax)
      complex*16 i
      parameter( i = (0.0d0, 1.0d0) )
      complex*16 resid(nrmax)
      real*8     P(nrmax), PU(nrmax), PL(nrmax), B(nrmax)
      complex*16 D(nrmax), DU(nrmax), DL(nrmax), F(nrmax)
      real*8 phinp1(nrmax), pinp1(nrmax)
      complex*16 psi_n(nrmax), psi_np1(nrmax)
      complex*16 psiaux_n(nrmax)
      real*8 Vnp1(nrmax),rp(nrmax),rm(nrmax)
      real*8 invert
      real*8 dt2, t2, dr2(nrmax), r2(nrmax), rp2(nrmax), rm2(nrmax)
      Nr = g1_Nr
      iterc = 1
      convg = 0
      phiconvg = 0
      piconvg = 0
      inform = 5

      firstloop = 1
c---------------------------------------------
c Define Half radii
c---------------------------------------------
       do j = 1, Nr
           rp(j) = r(j) + 0.5d0*dr
           rm(j) = r(j) - 0.5d0*dr
       end do

c      write(0,*) "epsiter is",epsiter
c       write(0,*) "dr is ",dr
c      write(0,*) "dt is ",dt

c--------------------------------------------
c Define new Time and Space variables (logarithm)
c--------------------------------------------
        t2 = t
       dt2 = dt
c       t2 = log( 1.0d0 + t )
c      dt2 = dt/( 1.0d0 + t )
       do j = 1, Nr
           r2(j) = r(j)
          dr2(j) = dr
          rp2(j) = rp(j)
          rm2(j) = rm(j)
c          r2(j) = log( 1.0d0 + r(j) )
c         dr2(j) = dr/( 1.0d0 + r(j) )
c         rp2(j) = log( 1.0d0 + rp(j) )
c         rm2(j) = log( 1.0d0 + rm(j) ) 
       end do 
c--------------------------------------------
c Define psi
c--------------------------------------------
      do j = 1, Nr
         psi_n(j) = phi_n(j) + i*pi_n(j)
         psiaux_n(j) = phiaux_n(j) + i*piaux_n(j)
      end do

      if ( vpass .eq. 1 ) then
c-------------------------------------------------------
c Initialize Norm using Simpson's Rule
c-------------------------------------------------------
c      norm_n(1) = 0.0d0
c      do j = 2, Nr
c         norm_n(j) = norm_n(j-1) 
c     & + dr2(j)*( psi_n(j-1)*conjg(psi_n(j-1))*r2(j-1)**2 
c     & + psi_n(j)*conjg(psi_n(j))*r2(j)**2  
c     & + ( psi_n(j-1) + psi_n(j) )*( conjg(psi_n(j-1) ) 
c     & + conjg(psi_n(j)) )*rm2(j)**2 )/6.0d0
c       end do
c--------------------------------------------------------
c Initialize Norm
c--------------------------------------------------------
      norm_n(1) = 0.0d0
      do j = 2, Nr
         norm_n(j) = norm_n(j-1) + 0.25d0*dr2(j)*(rm2(j)**2)
     &           *( psi_n(j) + psi_n(j-1) )
     &           *( conjg(psi_n(j)) + conjg(psi_n(j-1)) )
      end do
c--------------------------------------------------------
c Initialize Renorm
c--------------------------------------------------------
      do j = 1, Nr
         renorm_n(j) = norm_n(j)
      end do
c--------------------------------------------------------
c Renormalize the Wavefunction
c--------------------------------------------------------
      do j = 1, Nr
         psi_n(j) = psi_n(j)/sqrt(renorm_n(Nr))
      end do	 
c--------------------------------------------
c Define B
c--------------------------------------------
      do j = 1, Nr - 2
         B(j) = psi_n(j+1)*conjg(psi_n(j+1))
      end do
         B(Nr-1) = 0.0d0
c      write(0,*) 'B Defined'
c-------------------------------------------
c Initialization of V
c-------------------------------------------
c       write(0,*) "t is", t

c      call vsxynt('Bo',t,r(2),B,Nr-1)

c      write(0,*) 'Initializing V'
c--------------------------------------------
cDefine diagonal, superdiagonal, & subdiagonal
c--------------------------------------------
c      write(0,*) 'Defining D, DL, DU'
      do j = 2, Nr-2
        P(j) = -(3.0d0/dr2(j+1))*( rm2(j+1)**2 + rp2(j+1)**2 )/(
     &          rp2(j+1)**3 - rm2(j+1)**3 )
      end do 
         P(1) = (1.0d0/dr2(2))*(rm2(2)**2 - 3.0d0*rp2(2)**2 )/(
     &           rp2(2)**3 - rm2(2)**3 )
         P(Nr-1) = 1.0d0

      do j = 2, Nr-2
         PU(j) = (3.0d0/dr2(j+1))*(rp2(j+1)**2)/( rp2(j+1)**3 
     &         - rm2(j+1)**3 )
      end do
         PU(1) = (1.0/dr2(2))*( 3.0d0*rp2(2)**2 - rm2(2)**2 )/(
     &            rp2(2)**3 - rm2(2)**3 )
      do j = 1, Nr-3
         PL(j) = (3.0d0/dr2(j+2))*(rm2(j+2)**2)/( rp2(j+2)**3 
     &           - rm2(j+2)**3 )
      end do
         PL(Nr-2) = 0.0d0

c      write(0,*) 'PL,PU,P Defined'
c      write(0,*) PL
c      write(0,*) PU
c      write(0,*) P
c---------------------------------------------
c Call LAPACK to initialize V
c---------------------------------------------
        write(0,*) 'Calling DGTSV to solve initial V'

         call DGTSV( Nr-1, 1, PL, P, PU, B, Nr-1, inform )
         write(0,*) 'VinitINFO =', inform
c         write(0,*) 'Initial V solved'
c         write(0,*) 'DGTSV output:'
c         write(0,*) PL
c         write(0,*) PU
c         write(0,*) P

         do j = 2, Nr
            V_n(j)   = B(j-1)
c            write(0,*) V_np1(j)
c            write(0,*) dr
         end do
            V_n(1) = (4.0d0*V_n(2) - V_n(3))/3.0d0
c            write(0,*) V_n(1)

c         write(0,*) 'Initialization of V complete'     
c        call vsxynt('V_n',t,r,V_n,Nr)

c----------------------------------------------------
c Reset Normalization
c----------------------------------------------------
      do j = 1, Nr
	 V_n(j)   = V_n(j)*renorm_n(Nr)
      end do
 	 end if

      if ( vpass .eq. 0 ) then
c--------------------------------------------------------
c Update renorm
c--------------------------------------------------------
      do j = 1, Nr
         renorm_np1(j) = renorm_n(j)
      end do
c----------------------------------------------------
c Renormalize Wavefunction
c----------------------------------------------------
      do j = 1, Nr
         psi_n(j) = psi_n(j)/sqrt(renorm_n(Nr))
	 psiaux_n(j) = psiaux_n(j)/sqrt(renorm_n(Nr))
	 V_n(j) = V_n(j)/renorm_n(Nr)
      end do
      
c        write(0,*) "t is",t
c       write(0,*) 'Begin update of psi, V'
c------------------------------------------------------------
c Initially set advanced time level to retarted time level
c---------------------------------------------------------
      do j = 1,Nr
         Vnp1(j)   = V_n(j)
c         write(0,*) Vnp1(j)
      end do
c       call vsxynt('V_nstart',t,r,V_n,Nr)
c       call vsxynt('Vnp1start',t,r,Vnp1,Nr)
c       call vsxynt('V_np1start',t,r,V_np1,Nr)


c---------------------------------------------
c Main update loop
c---------------------------------------------
      do while ( (( convg .LT. Nr ) .OR. ( phiconvg .LT. Nr) .OR. 
     &	     ( piconvg .LT. Nr)) .AND. ( iterc .LT. iterma ) )
c       call vsxynt('V_nstart',t,r,V_n,Nr)
c       call vsxynt('Vnp1start',t,r,Vnp1,Nr)
c       call vsxynt('V_np1start',t,r,V_np1,Nr)

c----------------------------------------------
c Reset conditional variables
c----------------------------------------------
       convg = 0
       phiconvg = 0
       piconvg = 0
       inform = 0
c      write(0,*) 'Main Loop Begin'


c-------------------------------------------------------
c Calculate D, DU, DL, F for Psi
c-------------------------------------------------------
c      do j = 2, Nr - 2
c        D(j) = i - 0.75*(dt2/dr2(j+1))*( rp2(j+1)**2 + rm2(j+1)**2 )/(
c     &        rp2(j+1)**3 - rm2(j+1)**3 ) - couple*0.5d0*dt2*Vnp1(j+1)
c      end do 
c         D(1) = i + 0.25*(dt2/dr2(2))*( rm2(2)**2 - 3.0*rp2(2)**2 )/(
c     &           rp2(2)**3 - rm2(2)**3 ) - couple*0.5d0*dt2*Vnp1(2)
c         D(Nr - 1) = 1.0d0
c
c      do j = 2, Nr - 2
c         DU(j) = 0.75*(dt2/dr2(j+1))*(rp2(j+1)**2)/( rp2(j+1)**3 
c     &         - rm2(j+1)**3 )
c      end do
c         DU(1) = 0.25*(dt2/dr2(2))*(3.0*rp2(2)**2 - (rm2(2)**2) )/( 
c     &            rp2(2)**3 - rm2(2)**3 )
c  
c
c      do j = 1, Nr - 3
c         DL(j) = 0.75*(dt2/dr2(j+2))*(rm2(j+2)**2)/( rp2(j+2)**3 
c     &         - rm2(j+2)**3 )
c      end do
c         DL(Nr - 2) = 0.0d0
c
c      do j = 2, Nr - 2
c         F(j) = i*psi_n(j+1) - 0.75*(dt2/dr2(j+1))*( (psi_n(j+2) 
c     &     - psi_n(j+1))*rp2(j+1)**2 - (psi_n(j+1) - psi_n(j))
c     &     *rm2(j+1)**2 )/(rp2(j+1)**3 - rm2(j+1)**3 )
c     &     + couple*0.5d0*dt2*V_n(j+1)*psi_n(j+1) 
c      end do
c         F(1) = i*psi_n(2) - 0.75*(dt2/dr2(2))*( (psi_n(3) - psi_n(2))
c     &      *rp2(2)**2 - (1.0/3.0)*(psi_n(3) - psi_n(2))*rm2(2)**2 )/(
c     &       rp2(2)**3 - rm2(2)**3 ) + couple*0.5d0*dt2*V_n(2)*psi_n(2)
c
c         F(Nr-1) = 0.0d0
c-------------------------------------------------------
c Calculate D, DU, DL, F for Psi
c-------------------------------------------------------
      do j = 2, Nr - 2
       D(j) = i - 0.5d0*(3.0/( rp2(j+1)**3 - rm2(j+1)**3))
     & * ( rp2(j+1)**2 * 0.5d0*(dt2/dr2(j+1)) 
     & + rm2(j+1)**2 * 0.5d0*(dt2/dr2(j+1)) ) 
     & - dt2*0.5d0*couple*Vnp1(j+1)
     & - kappa*(3.0d0/( rp2(j+1)**3 - rm2(j+1)**3) )
     & * ( rp2(j+1)**2 * 0.5d0 *(dt2/dr2(j+1))*Vnp1(j+1)
     & * ( Vnp1(j+2) - Vnp1(j+1) ) - rm2(j+1)**2*0.5d0*(dt2/dr2(j+1))
     & * Vnp1(j+1)*( Vnp1(j+1) - Vnp1(j) ) )
       end do

       D(1) = (4.0d0/3.0d0)*0.5d0*(3.0d0/( rp2(2)**3 - rm2(2)**3 ) )
     & *rm2(2)**2 * 0.5d0*(dt2/dr2(2)) 
     & + i - 0.5d0*(3.0d0/(rp2(2)**3 - rm2(2)**3 ) )
     & *( rp2(2)**2 * 0.5d0*(dt2/dr2(2)) + rm2(2)**2 
     & * 0.5d0*(dt2/dr2(2))) - 0.5d0*dt2*couple*Vnp1(2)
     & - kappa*(3.0d0/( rp2(2)**3 - rm2(2)**3))
     & *( rp2(2)**2 * 0.5d0*(dt2/dr2(2))*Vnp1(2)*( Vnp1(3) - Vnp1(2) )
     & -  rm2(2)**2 * 0.5d0*(dt2/dr2(2))*Vnp1(2)*( Vnp1(2)
     & - (1.0d0/3.0d0)*( 4.0d0*Vnp1(2) - Vnp1(3) ) ) )

         D(Nr - 1) = 1.0d0


      do j = 2, Nr - 2
         DU(j) = 0.5d0*(3.0d0/( rp2(j+1)**3 - rm2(j+1)**3 ))
     & * rp2(j+1)**2 * 0.5d0*(dt2/dr2(j+1))
      end do

       DU(1) = 0.5d0*(3.0d0/( rp2(2)**3 - rm2(2)**3))*rp2(2)**2 
     & * 0.5d0*(dt2/dr2(2)) - (1.0d0/3.0d0)
     & * 0.5d0*(3.0d0/(rp2(2)**3 - rm2(2)**3))*rm2(2)**2 
     & * 0.5d0*(dt2/dr2(2))

      do j = 1, Nr - 3
       DL(j) = 0.5d0*(3.0d0/( rp2(j+2)**3 - rm2(j+2)**3 ))*rm2(j+2)**2
     & 	* 0.5d0*dt2/dr2(j+2)
      end do
         DL(Nr - 2) = 0.0d0

      do j = 2, Nr - 2
       F(j) = i*psi_n(j+1) - 0.5d0*(3.0d0/(rp2(j+1)**3 - rm2(j+1)**3))
     & * ( rp2(j+1)**2 * 0.5d0*(dt2/dr2(j+1))*(psi_n(j+2) - psi_n(j+1))
     & - rm2(j+1)**2 * 0.5d0*(dt2/dr2(j+1))*( psi_n(j+1) - psi_n(j) ) )
     & + dt2*couple*0.5d0*V_n(j+1)*psi_n(j+1)
     & + kappa*(3.0d0/( rp2(j+1)**3 - rm2(j+1)**3 ))
     & *( rp2(j+1)**2 * 0.5d0*(dt2/dr2(j+1))*V_n(j+1)*psi_n(j+1)
     & *( V_n(j+2) - V_n(j+1) ) - rm2(j+1)**2 * 0.5d0*(dt2/dr2(j+1))
     & * V_n(j+1)*psi_n(j+1)*( V_n(j+1) - V_n(j) ) )
       end do
      
       F(1) = i*psi_n(2) - 0.5d0*(3.0d0/( rp2(2)**3 - rm2(2)**3 ))
     & * ( rp2(2)**2 * 0.5d0*(dt2/dr2(2))*( psi_n(3) - psi_n(2) )
     & - rm2(2)**2 * 0.5d0*(dt2/dr2(2))*( psi_n(2) - psi_n(1) ) )
     & + dt2*couple*0.5d0*V_n(2)*psi_n(2)
     & + kappa*(3.0d0/( rp2(2)**3 - rm2(2)**3 ))
     & *( rp2(2)**2 * 0.5d0*(dt2/dr2(2))*V_n(2)*psi_n(2)
     & *( V_n(3) - V_n(2) ) - rm2(2)**2 * 0.5d0*(dt2/dr2(2))
     & * V_n(2)*psi_n(2)*( V_n(2) - V_n(1) ) )
   
       F(Nr-1) = 0.0d0


         call ZGTSV( Nr-1, 1, DL, D, DU, F, Nr-1, inform )
         write(0,*) 'Psi INFO=', inform   

c----------------------------------------------------------
c Update Psi
c----------------------------------------------------------
      do j = 2, Nr
         psi_np1(j) = F(j-1)
      end do
         psi_np1(1) = (4.0d0*psi_np1(2) - psi_np1(3))/3.0d0

c-------------------------------------------------------
c Calculate Norm using Simpson's Rule
c-------------------------------------------------------
c      norm_np1(1) = 0.0d0
c      do j = 2, Nr
c         norm_np1(j) = norm_np1(j-1) 
c     & + dr2(j)*( psi_np1(j-1)*conjg(psi_np1(j-1))*r2(j-1)**2 
c     & + psi_np1(j)*conjg(psi_np1(j))*r2(j)**2  
c     & + ( psi_np1(j-1) + psi_np1(j) )*( conjg(psi_np1(j-1) ) 
c     & + conjg(psi_np1(j)) )*rm2(j)**2 )/6.0d0
c      end do
c--------------------------------------------------------
c Calculate Norm
c--------------------------------------------------------
      norm_np1(1) = 0.0d0
      do j = 2, Nr
         norm_np1(j) = norm_np1(j-1) + 0.25d0*dr2(j)*(rm2(j)**2)
     &           *( psi_np1(j) + psi_np1(j-1) )
     &           *( conjg(psi_np1(j)) + conjg(psi_np1(j-1)) )
      end do

c------------------------------------------------------
c      write(0,*) 'Determine B for calculation of V'
c------------------------------------------------------
      do j = 1, Nr - 2
         B(j) = psi_np1(j+1)*conjg(psi_np1(j+1))
      end do
        B(Nr-1) = 0.0d0
c       call vsxynt('Biter',t,r(2),B,Nr-1)      

c--------------------------------------------
cDefine diagonal, superdiagonal, & subdiagonal
c--------------------------------------------
      do j = 2, Nr-2
        P(j) = -(3.0d0/dr2(j+1))*( rm2(j+1)**2 + rp2(j+1)**2 )/(
     &          rp2(j+1)**3 - rm2(j+1)**3 )
      end do 
         P(1) = (1.0d0/dr2(2))*(rm2(2)**2 - 3.0d0*rp2(2)**2 )/(
     &           rp2(2)**3 - rm2(2)**3 )
         P(Nr-1) = 1.0d0

      do j = 2, Nr-2
         PU(j) = (3.0d0/dr2(j+1))*(rp2(j+1)**2)/( rp2(j+1)**3 
     &         - rm2(j+1)**3 )
      end do
         PU(1) = (1.0d0/dr2(2))*( 3.0d0*rp2(2)**2 - rm2(2)**2 )/(
     &            rp2(2)**3 - rm2(2)**3 )
      do j = 1, Nr-3
         PL(j) = (3.0d0/dr2(j+2))*(rm2(j+2)**2)/( rp2(j+2)**3 
     &           - rm2(j+2)**3 )
      end do
         PL(Nr-2) = 0.0d0

c-----------------------------------------------
c Invert using LAPACK
c-----------------------------------------------
         call DGTSV( Nr-1, 1, PL, P, PU, B, Nr-1, inform )
         write(0,*) 'V INFO =',inform
         do j = 2, Nr
            V_np1(j)   = B(j-1)
c            write(0,*) V_np1(j)
c            write(0,*) dr
         end do
            V_np1(1) = (4.0d0*V_np1(2) - V_np1(3))/3.0d0
c            write(0,*) V_np1(1)
c       call vsxynt('V_np1',t2,r2,V_np1,Nr)
c       call vsxynt('psi_np1',t2,r2,psi_np1,Nr)

c--------------------------------------------------------
c Calculate Independent Residual
c---------------------------------------------------------
      if ( t .EQ. 0 ) then
         do j = 1, Nr
            residre_np1(j) = residre_n(j)
            residim_np1(j) = residim_n(j)
         end do
      else
      do j = 2, Nr - 1
      resid(j) = 0.5d0*i*((psi_np1(j) - psiaux_n(j))/dt2)
     & + 0.5d0*( 3.0d0/(rp2(j)**3 - rm2(j)**3) )
     & * ( (rp2(j)**2) * (( psi_n(j+1) - psi_n(j) )/dr2(j) )
     & - (rm2(j)**2) * ( psi_n(j) - psi_n(j-1) )/dr2(j) )
     & - couple*V_n(j)*psi_n(j)
     & - kappa*V_n(j)*psi_n(j)*(3.0d0/(rp2(j)**3 - rm2(j)**3 ))
     & * ( rp2(j)**2 * ( V_n(j+1) - V_n(j) )/(dr2(j))
     & - rm2(j)**2 * ( V_n(j) - V_n(j-1) )/(dr2(j)) )
       end do

                     
       resid(1) = (4.0d0*resid(2) - resid(3))/3.0d0

       residre_np1(Nr) = 0.0d0
       residim_np1(Nr) = 0.0d0
       do j = 1, Nr
          residre_np1(j) = dble(resid(j))
          residim_np1(j) = imag(resid(j))
       end do
       end if
              
c---------------------------------------------------------
c Check for convergence
c---------------------------------------------------------

      if ( firstloop .eq. 0 ) then
c       write(0,*) 'Check for Convergence'
c            write(0,*) Vnp1(1)
            write(0,*) "Vconvg is ", DABS(V_np1(1) - Vnp1(1))
            write(0,*) "piconvg is ", DABS(pi_np1(1) - pinp1(1))
         do j = 1, Nr
            if ( DABS(V_np1(j) - Vnp1(j)) .LT. epsiter ) then
               convg = convg + 1
            end if
c            write(0,*) DABS(V_np1(j) - Vnp1(j))

         if ( DABS( dble(psi_np1(j)) - phinp1(j) ) .LT. epsiter ) then
                 phiconvg = phiconvg + 1
            end if
           
	  if ( DABS( imag(psi_np1(j)) - pinp1(j) ) .LT. epsiter ) then
                 piconvg = piconvg + 1
            end if
         end do
       end if
c-----------------------------------------------------------
c Exit convergence
c-----------------------------------------------------------
       firstloop = 0

c--------------------------------------------------------
c Save phinp1,pinp1 for convergence testing
c--------------------------------------------------------
       do j = 1,Nr
          phinp1(j) = dble(psi_np1(j))
	  pinp1(j) = imag(psi_np1(j))
       end do

c----------------------------------------------------------
c No convergence. Set counter variables
c---------------------------------------------------------
      write(0,*) "couple is", couple
      write(0,*) 'No convergence after ', iterc, ' iteration(s)'
      write(0,*) "renorm is", renorm_n(Nr)
c      convg = 0
      iterc = iterc + 1
      
      do j = 1,Nr
         Vnp1(j)   = V_np1(j)
      end do
        
      end do
c--------------------------------------      
c     Exit Loop
c--------------------------------------
c----------------------------------------------------
c Reset Normalization
c----------------------------------------------------
      do j = 1, Nr
         psi_n(j) = psi_n(j)*sqrt(renorm_n(Nr))
	 psi_np1(j) = psi_np1(j)*sqrt(renorm_n(Nr))
	 V_n(j) = V_n(j)*renorm_n(Nr)
	 V_np1(j) = V_np1(j)*renorm_n(Nr)
         norm_np1(j) = norm_np1(j)*renorm_n(Nr)
      end do

c----------------------------------------------------------
c Send output to RNPL defined grid functions
c----------------------------------------------------------
      do j = 2, Nr
         phi_np1(j) = dble(psi_np1(j))
          pi_np1(j) = imag(psi_np1(j))
      end do
         phi_np1(1) = dble(psi_np1(1))
          pi_np1(1) = imag(psi_np1(1))

c---------------------------------------------------------
c Update auxillary functions
c---------------------------------------------------------
      do j = 1, Nr
          phiaux_np1(j) = phi_n(j)
           piaux_np1(j) = pi_n(j)
            Vaux_np1(j) = V_n(j)
      end do


      convg = 0
      phiconvg = 0
      piconvg = 0
      iterc = 0

      end if
